# ****************************************************************************
# Surgeweb javascript - User interface handler functions
# Note: sw.js is the primary surgeweb javascript code
# ----------------------------------------------------------------------------
#  These functions are designed to be called from multipe user interface elements etc 
# ****************************************************************************

function swcmd(action,e,input)
{
#	alert("requested to:"+action+" the messages="+sel.join(','));
	if (action.length==0) return;
	if (action=='sw_delete') 	do_delete();
	else if (action=='sw_read')		do_mark_read();
	else if (action=='sw_unread')	do_mark_unread();
	else if (action=='sw_reply_all')	do_reply_all();
	else if (action=='sw_redirect')	do_redirect();
	else if (action=='sw_forward_attach') 	do_forward_attach();
	else if (action=='sw_forward') 	do_forward();
	else if (action=='sw_reply') 	do_reply();
	else if (action=='sw_cache') 	do_cache();
	else if (action=='sw_compose') 	do_compose(e);
	else if (action=='sw_edit') 	do_edit();
	else if (action=='sw_print') 	do_print();
	else if (action=='sw_copy') 	do_copy_show(e,input);
	else if (action=='sw_move') 	do_move_show(e,input);
	else if (action=='sw_spam') 	do_spam();
	else if (action=='sw_notspam') 	do_notspam();
	else if (action=='sw_download_msg') 	do_download_msg();
	else alert('Sorry  don\'t know how to '+action+' yet');
}

function do_reply()
{
	var e=window.event;
	var sel=find_sel();
	if (!check_sel(sel,'replied to')) return;
	var jmsg=sel_to_jmsg(sel,'reply');
	show_edit(jmsg,e);
}

function do_mark_unread()
{
	var sel=find_sel();
	if (!sel) return;
	ajax_set_flags(sel,'clear','seen',function(node){class_add(node,'msg_unread')})
	do_select('none');
}
function do_mark_read()
{
	var sel=find_sel();
	if (!sel) return;
	ajax_set_flags(sel,'set','seen',function(node){class_remove(node,'msg_unread')})
	do_select('none');
}

function check_sel(sel,type)
{
	if (!sel) return false;
	if (sel.length>1) alert('Only one message at a time can be '+type+'. First selected message is getting used.');
	return true;
}

function do_forward(){
	var e=window.event;
	var sel=find_sel();
	if (!sel) return false;
	var jmsg=sel_to_jmsg(sel,'forward')
	show_edit(jmsg,e);
}
function do_reply_all(){
	var e=window.event;
	var sel=find_sel();
	if (!check_sel(sel,'replied to')) return;
	var jmsg=sel_to_jmsg(sel,'replyall')
	show_edit(jmsg,e);
}
function do_redirect(){
	var e=window.event;
	var sel=find_sel();
	if (!check_sel(sel,'redirected')) return;
	var jmsg=sel_to_jmsg(sel,'redirect')
	show_edit(jmsg,e);
}
function do_forward_attach(){
	var e=window.event;
	var sel=find_sel();
	if (!sel) return false;
	var jmsg=sel_to_jmsg(sel,'forward_attach')
	jmsg.msg_html='';
	show_edit(jmsg,e);
}
function do_edit()
{
	var e=window.event;
	var sel=find_sel();
	if (!sel) return;
	var jmsg=sel_to_jmsg(sel,'edit')
	show_edit(jmsg,e);
}

function do_notspam()
{
	var sel=find_sel();
	if (!sel) return;
	ajax_spam_rating(sel,'notspam',function(node){class_remove(node,'foo')})
	do_select('none');
}

# Used for testing currently :-)
function do_spam()
{
	var sel=find_sel();
	if (!sel) return;
	ajax_spam_rating(sel,'spam',function(node){class_remove(node,'foo')})
	do_select('none');
}


function do_history(){
	x_alert("Unimplemented: This should do a serverside search showing a history of messages to / from this person");
}

function show_raw(mid)
{
	dbg("show_raw");
	open_popup('cmd=msgpart&sid='+sid+'&fld_id='+sw.fid+'&msg_id='+mid+'&part_id=0');
}
function show_text(mid,pid)
{
	dbg("show_html");
#	headers now say text/plain instead of text/html so no web encoding should be required
	open_popup('cmd=msgpart&sid='+sid+'&fld_id='+sw.fid+'&msg_id='+mid+'&part_id='+pid);
}
function show_html(mid,pid)
{
	dbg("show_html");
	open_popup('cmd=msgpart&sid='+sid+'&fld_id='+sw.fid+'&msg_id='+mid+'&part_id='+pid+'&process=simple_wash');
}
function show_img(pid)
{
#	QQQ turn cursor_mid into parameter

	open_popup('cmd=msgpart&sid='+sid+'&fld_id='+sw.fid+'&msg_id='+cursor_mid+'&part_id='+pid);
}

function do_customise()
{
	x_alert("Sorry, menu customise not implemented just yet.");
}

function do_na(txt)
{
	x_alert("Sorry, "+txt+" not implemented yet");
}

function do_folder_manage()
{
	sndReq('cmd=show&page=~folders.htm', function(chan){
		node=actionReqSethtml(chan.responseText,'utility');
	});
}

function do_compose(e)
{
	dbg('do_compose');
	show_edit(compose_jmsg([]),e);
	return stopEvent(e);
}

function edit_discard()
{
	if(!sw.active.unsaved){
		edit_discard_real();
	}else{
		x_confirm("The message you have been writing will be lost. Are you sure?",function(n){
			if (!n)return;
			edit_discard_real();
		});
	}
}
function edit_discard_real()
{
	if (sw.is_popup) {
		sw.closing=true;
		window.close();
		return;
	}
	window_manager_killpane(sw.active);
	set_status("Message discarded","success");

	window_manager_restore();
}



function msg_list_dblclick(e){
	var t=target(e);
	var row=find_message_row(t);
	var valid_row=row_to_sel(row);
	if (!valid_row) return;
	var mid=valid_row.id.substring(4);
	if (e.shiftKey || e.ctrlKey){
		select_none_fast();
		msglist_select(mid);	
	}
	if (pref.mode=='web')
		preview_msg(mid)
	show_msg(mid,e);
}
# QQSEL CLICK
function msg_list_click(e){
	// select more than one if we have to...
	var t=target(e);
	var tag=t.tagName.toLowerCase();
	var row=find_message_row(t);
	var web = pref.mode=='web' && tag=="a";

	// Handle the clicking of select boxes...
	if (tag=="input"){
		var sel=t;
		if (e.shiftKey && shift_sel_start){
			complete_selection(row,sel.checked?true:false)
		}else{
			if(cursor_row && cursor_row.sel && !row_to_sel(cursor_row).checked) row_unselect(cursor_row);
			node=sel_to_row(t);
			if (sel.checked)
				row_select(node,true);
			else
				row_unselect(node);
		}
		cursor_mid=sel_to_mid(sel);
#		cursor_row=node;
	} else {
		// click anywhere in a row
		var td=find_message_td(t);
		if (td==row.firstChild || td==row.firstChild.nextSibling) return;
		var valid_sel=row_to_sel(row);
		if (!valid_sel) return;
		
		var unselect;
		if (!(e.shiftKey || e.ctrlKey) || web)
			select_none_fast();
		unselect=valid_sel.checked;
		if (!web){
			if (e.shiftKey && shift_sel_start){
				complete_selection(row,row.sel==true?false:true)
			}else if (e.ctrlKey){
				if (unselect){
					if(cursor_row) row_unselect(cursor_row);
					row_unselect(row);
				}else{
					if(cursor_row) row_select(cursor_row,true);
					row_select(row,true);
				}
			}
		}
		var mid=sel_to_mid(valid_sel);
		if (!unselect){
			msglist_select(mid,true);	
		}
		if (pref.mode=='app'){
			preview_msg(mid);
		}
		if (web){
			dbg("*** new handler :-) showing msg");
			show_msg(mid,e);		// This depends on separate retrieval of actual message content
		}
	}
	shift_sel_start=row;
	touch(8);
	if (tag!="input") 
		return false;
}

var last_retr_mid, last_retr_time;
function retrieve_msg(fld,mid,cb,extra,nostatus)
{
	var now=new Date().getTime();
	if(last_retr_mid==mid && last_retr_time>now-1000) {
		dbg("IGNORING retrieve_msg request - too soon, mid="+mid);
		return;
	}
	dbg("retrieve_msg request mid="+mid);
	last_retr_time=now;
	last_retr_mid=mid;
	if(!extra) extra='';

	sndReq('cmd=show&page=~msg.js&msg_id='+mid+"&fld_id="+fld+extra, function(chan){
		if (chan.status!=200){
			success_string="Communication error - server not reachable";
			set_status('Failed to retrieve message : '+success_string,'warning');
			if(cb) cb(false);
			return;
		}else{
			if(!nostatus) set_status();
		}

		var success=actionReqJsStat(chan);
		cache_add(sw.fid+'_'+mid, amsg);
		if(cb) cb(true);
	});
}

function assign_destination_html(destination,mid,txt)
{
	var el=dge(destination);
	el.innerHTML=txt;
	el.scrollTop=0;	
	if(destination=='message_preview')
		preview_mid=mid;
}

var seen_timer;
var amsg,allmsgs;
var preview_mid;
# Asynchronously retrieve message (and do any requested completion action - only used for preview)
# This should really start using the actual retrieve_msg function
function preview_msg(mid,cb,nostatus)
{
	if (seen_timer) clearTimeout(seen_timer);

	var destination;
	if (pref.mode=='app' && pref.window!='none')
		destination='message_preview';

	var fld=sw.fid;

	dbg("preview message id=="+mid+" display 2");

	cursor_mid=mid;
	var idx=sw.fid+'_'+mid;

	if(sw_cache && sw_cache[idx]){
		dbg("attempting to load message id="+mid+" from cache");
		var qmsg=sw_cache[idx];
		assign_destination_html(destination,mid,html_from_qmsg(qmsg));
		special_processing(destination,qmsg);	

		set_status();
		if (class_contains(sel_to_row(document.getElementById('sel_'+cursor_mid)),'msg_unread')){
			ajax_set_flags(make_sel(sw.fid,cursor_mid),'set','seen',function(node){class_remove(node,'msg_unread')})
		}
	}else{
		if (destination) set_loading(destination);
		
		retrieve_msg(sw.fid,mid, function(success){
			if (destination) doneloading();
			if (!success) return;
#			if (global_auth_error) {
#				global_auth_error=false;
#				return;
#			}
#			dge(destination).innerHTML=amsg.html;

			var qmsg=sw_cache[idx];
			assign_destination_html(destination,mid,html_from_qmsg(qmsg));
			special_processing(destination,qmsg);	

			//fire of a "read" "request"
			var el=document.getElementById('sel_'+mid);
			if (!el) return;
			if (class_contains(sel_to_row(el),'msg_unread'))
				ajax_set_flags(make_sel(sw.fid,mid),'set','seen',function(node){class_remove(node,'msg_unread')})
		},nostatus);	
	}
}

function special_processing(destination,qmsg)
{
	if(destination=='message_preview'){
		var o=dge('msg_to');
		if(!class_contains(o.parentNode,'hidden_in_preview') && !class_contains(dge('msg_cc').parentNode,'hidden') && qmsg.data.nrcpts_to<=2)
			class_add(o.parentNode, 'float_left');
	}
}


function do_logout()
{
	sw.closing=true;
	var f=document.main;
	f.submit();
}


function do_delete(force)
{

	if (sw.is_popup){
		sw_win.do_delete2(sw.mid);
		window.close();
		return;
	}

	var sel=find_sel(true);
	if (!sel) return;

	if (!pref['confirm_delete'] || force || sel.length==1 ){
		do_delete_step2(sel);
		return;
	}
	x_confirm('Deleting '+sel.length+' messages. Are you sure?',function(n){
		if (!n)return;
		do_delete_step2(sel);
	});
}
function do_delete_step2(sel)
{
	set_status("Deleting...","info");
	do_select('none');
	ajax_delete(sel);
	message_done_action(sel);
}

function do_options()
{
	node=sw.active;
	if (node && node.className=="compose")
		window_manager_minimise(node);

	sndReq('cmd=show&page=~options.htm', function(chan){
#		// Same in manage_folders
		if (chan.status!=200){
			success_string="Communication error - server not reachable";
			set_status(success_string,'warning');
			return false;
		}
		node=actionReqSethtml(http.responseText,'utility');
		if (global_auth_error){
			global_auth_error=false;
			window_manager_restore();
		}		
	});
}

function options_discard()
{
	window_manager_killpane(sw.active);
	set_status("Changes to options discarded","success");
	window_manager_restore();	
}

function options_save()
{
	var fake_form, real_form, pane, recache;
	real_form=document.options;
	var o=dge('eframe_sig').contentWindow;
	var newsig=o.document.body.innerHTML;
	real_form.pref_signature.value=newsig.replace(/\n/g,'').replace(/\r/g,'');
	if(newsig.length>1000){
		alert('Your signature is '+newsig.length+' characters long and currently cannot be longer than approx 970 characters - signature will be truncated, posibly resulting in odd behaviour.\n\nnote: html tag characters are part of character count');
	}

	var btns=toolbar_buttons_get();

#	Send everything to the server
	fake_form='cmd=save_options,show&page=~result.js';
#	fake_form+='&to='+real_form.to.value;

	fake_form+='&pref_no_fancy_rcpt='+real_form.pref_no_fancy_rcpt.checked;
	fake_form+='&pref_nocache='+real_form.pref_nocache.checked;
	fake_form+='&pref_nocompress='+real_form.pref_nocompress.checked;
	fake_form+='&pref_sticky_menus='+real_form.pref_sticky_menus.checked;
	fake_form+='&pref_reply='+encodeURIComponent(real_form.pref_reply.value);
	fake_form+='&pref_timezone='+real_form.pref_timezone.value;
	fake_form+='&pref_imap_refresh='+real_form.pref_imap_refresh.checked;
	fake_form+='&pref_signature='+xescape(real_form.pref_signature.value);

	fake_form+='&pref_date_format='+real_form.pref_date_format.value;
	fake_form+='&pref_time_format='+real_form.pref_time_format.value;
	fake_form+='&pref_message_done_action='+real_form.pref_message_done_action.value;
	fake_form+='&pref_message_done_action2='+real_form.pref_message_done_action2.value;
	fake_form+='&pref_allow_images='+real_form.pref_allow_images.value;
	fake_form+='&pref_sounds='+real_form.pref_sounds.value;
	fake_form+='&pref_edit_mode='+real_form.pref_edit_mode.value;
	fake_form+='&pref_noautoadd='+real_form.pref_noautoadd.checked;
	fake_form+='&pref_custom='+real_form.pref_custom.value;

#	This line needs to go
#	fake_form+='&pref_layout='+real_form.pref_layout.value;

	fake_form+='&pref_mode='+real_form.pref_mode.value;
	fake_form+='&pref_preview='+radio_value(real_form.pref_preview);
	fake_form+='&pref_windows='+radio_value(real_form.pref_windows);

	fake_form+='&pref_devt_mode='+real_form.pref_devt_mode.checked;
	fake_form+='&pref_nocheck='+real_form.pref_nocheck.checked;
	fake_form+='&pref_unimplemented='+real_form.pref_unimplemented.checked;

	fake_form+='&pref_colour='+real_form.pref_colour.value;
	fake_form+='&pref_image_resize='+real_form.pref_image_resize.value;

	fake_form+='&pref_spellcheck_language='+real_form.pref_spellcheck_language.value;

	fake_form+='&pref_toolbar_buttons='+btns;

	for(var i=1;i<=6;i++){
		fake_form+='&pref_folder_move_'+i+'='+xescape(real_form['pref_folder_move_'+i].value);
	}

	pane=sw.active;
	set_status("Saving options...","info");
	sndReqPost(fake_form, function(chan){
		var success=actionReqJsStat(chan);			
		

		// Do success fail check
		set_status('Options saved. Now <a href="#" onclick="do_reload()">reload page</a> if required.',"success");		

#	Update relevant local settings
		signature=real_form.pref_signature.value;
		pref_reply=real_form.pref_reply.value;

		pref.message_done_action=real_form.pref_message_done_action.value;
		pref.message_done_action2=real_form.pref_message_done_action2.value;

		pref.sounds=real_form.pref_sounds.value;
		pref.mode=real_form.pref_mode.value
		pref.preview=real_form.pref_preview.value
		pref.windows=real_form.pref_windows.value
		pref.sticky_menus=real_form.pref_sticky_menus.value
		pref.no_fancy_rcpt=real_form.pref_no_fancy_rcpt.value
		if(pref.allow_images!=real_form.pref_allow_images.value){
			pref.allow_images=real_form.pref_allow_images.value;
			cache_clear();
		}

		if(pref.nocache!=real_form.pref_nocache.checked || !done_cache){
			pref.nocache=real_form.pref_nocache.checked;
			if (pref.nocache){
				cache_clear();
			}else{
				var fld=sw.fid;
				if(fld=='INBOX'){
					var msgs=find_msgs();
					if (msgs.length==0) return;
					setTimeout(function(){		
						done_cache=true;
						ajax_cache_messages(msgs);	
					},400);
				}
			}
		}
		if(pref.toolbar_buttons!=btns){
			pref.toolbar_buttons=btns;
			toolbar_buttons_customise(btns);
		}
		window_manager_killpane(sw.active);
#		panel_remove(pane);
		window_manager_restore();	
	});	
}

# QQSEL
function do_select(type)
{
	var nodes=sw.msgs_panelist.getElementsByTagName("tr");
	if (type=='all'){
		for(var i=0; i < nodes.length; i++){
			var node = nodes[i];
			if (!class_contains(node,'hidden'))
				row_select(node,true);
		}
	}else if(type=='none'){
		for(var i=0; i < nodes.length; i++){
			var node = nodes[i];
			row_unselect(node);
		};
		fastselect_hitcount=0;
	}else if(type=='new'){
		for(var i=0; i < nodes.length; i++){
			var node = nodes[i];
			if (!class_contains(node,'hidden')){
				if (class_contains(node,'msg_unread'))
					row_select(node,true);
				else
					row_unselect(node);
 			}
		};
	}else if(type=='read'){
		for(var i=0; i < nodes.length; i++){
			var node = nodes[i];
			if (!class_contains(node,'hidden'))
				if (class_contains(node,'msg_unread'))
					row_unselect(node);
				else
					row_select(node,true);
		};
	}else if(type=='replied'){
		for(var i=0; i < nodes.length; i++){
			var node = nodes[i];
			if (!class_contains(node,'hidden'))
				if (class_contains(node,'msg_replied'))
					row_select(node,true);
				else
					row_unselect(node);
		};
	}

	select_mailbox_all(type);
}
function select_mailbox_all(type)
{
	if(sw.nav_count==sw.nav_total)	return;
	var ex=dge('list_extra');
	if(type=='all'){
		if (sw.nav_total>0 && !sw.search_input.valid){
			class_remove(ex,'hidden');
			class_remove(ex,'all_sel');
			ex.innerHTML='All '+sw.nav_count+' messages on this page selected. <a href="#" onclick="select_mailbox_all(\'folder_all\')">Select all '+sw.nav_total+' in '+sw.fid+' folder</a>';
		}
		sw.sel_all=false;
	}else if(type=='folder_all'){
		class_remove(ex,'hidden')
		class_add(ex,'all_sel');
		ex.innerHTML='All '+sw.nav_total+' messages in '+sw.fid+' folder selected. <a href="#" onclick="do_select(\'none\')">Clear selection</a>';
		sw.sel_all=true;
	}else{
		class_add(ex,'hidden')
		sw.sel_all=false;
	}
}
function deselect_mailbox_all()
{
	var ex=dge('list_extra');
	class_add(ex,'hidden')
	sw.sel_all=false;
}


function clear_indexes()
{
	dbg('Clearing indexes serverside');
	x_confirm('This will log you out are you sure?',function(n){
		if (!n) return;
		sndReq('cmd=clear_indexes,show&page=~result.js', function(chan){
			dbg('response came back, unknown status');
			do_logout();
		});
	});
}

function manage_folders(e)
{
#	//	window_manager_minimise(sw.active);
	sndReq('cmd=show&page=~folders.htm', function(chan){
#		// same in do_options factor out into common code
		if (chan.status!=200){
			success_string="Communication error - server not reachable";
			set_status(success_string,'warning');
			return false;
		}
		node=actionReqSethtml(chan.responseText,'utility');
		if (global_auth_error){
			global_auth_error=false;
			window_manager_restore();
		}		
	});
	stopEvent(e);
	return false;
}

function index_dump()
{
	sndReq('cmd=index_dump&page=~folders.htm&fld_id='+sw.fid, function(chan){
//		node=actionReqSethtml(http.responseText,'utility');
	});
}
function folders_done()
{
	window_manager_minimise(sw.active);
	window_manager_restore();	
}

//qqqtab
function tab_close(id){
	var tabtokill=document.getElementById(id);
	tabtokill.closing=true;
	if(tabtokill.node_ref==sw.active){
		window_manager_killpane(tabtokill.node_ref);
		window_manager_restore();
	}else{
		window_manager_killpane(tabtokill.node_ref);
	}
	
#	Make sure we remove the additional nodes too??	

# 	does not work FF/Saf (does in IE) so use tabtokill.closing instead
#	return stopEvent();		
}

function do_save_draft(auto,cb)
{

	var node,win,src_win;
	if(sw.is_popup){
		node=sw.active;
		node.sw_win = sw_win;
		node.is_popup=true;
		win=sw_win;// Pass the send through the parent frame if we can
		if(sw.run_spellcheck_once) win.sw.run_spellcheck_once=true;
	}else{
		win=window;
		node=sw.active;
	}
	src_win=window;
	
	spellcheck_markup_removeall(!auto&&!sw.run_spellcheck_once);	
	win.popup_spellcheck=window;
	
	var jmsg=jmsg_update(node);
	win.ajax_save_draft(jmsg,undefined,function(jsmsg){
		var o=src_win.document.getElementById('compose_info');
		if (o) o.innerHTML='Draft '+(auto?'auto ':'')+'saved at '+time_str();
		if (cb) cb();
	});

	if(autosave_timer){
		clearTimeout(autosave_timer);
		autosave_timer=null;
	}
}

function sel_and_action(id)
{
	setTimeout(function(){
		var sel=find_sel(true);
		if (!sel) return;
		if (sel.join(',')==id.join(',')){
			do_select('none');			
			message_done_action(sel);
		}
	},150);
}

function do_send_move()	// cf ajax_send, do_move, 
{
	var node=sw.active;
	if(sw.is_popup){
		node.sw_win = sw_win;
		node.is_popup=true;
		var jmsg=jmsg_update(node);
		sw_win.ajax_send(jmsg,true);
#		sw_win.ajax_send(_node,true);// Pass the send through the parent frame if we can
		sw_win.sel_and_action(jmsg.sel_mids);
		sw_win.focus();
		sw.closing=true;
		window.close();
	}else{

		var jmsg=jmsg_update(node);
		ajax_send(jmsg,true);
#		ajax_send(_node,true);
		sel_and_action(jmsg.sel_mids);
	}
}
function do_send()
{
	var node=sw.active;

	if(sw.is_popup){
		node=sw.active;
		node.sw_win = sw_win;
		node.is_popup=true;
		if(!main_window_check(node)) return;
		var jmsg=jmsg_update(node);
		sw_win.ajax_send(jmsg);
#		sw_win.ajax_send(_node);// Pass the send through the parent frame if we can
		sw_win.sel_and_action(jmsg.sel_mids);
		sw_win.focus();
		sw.closing=true;
		window.close();
	}else{
		var jmsg=jmsg_update(sw.active);
		ajax_send(jmsg);
		sel_and_action(jmsg.sel_mids);
	}
}

#var app_warning=true;
function do_old(type)
{
	var cmd;

	if (type!="mail" && type!="contacts" && !pref.hide_integration_warning){
		alert("Calendar, Photos and Blogs are not yet fully integrated\ninto the Ajax interface but instead displayed within an iframe.\n\nAt some stage in the near future integration will be improved.");
		ajax_pref_save('pref_hide_integration_warning=true');
		pref.hide_integration_warning=true;
	}

	if (type=='mail'){
		if (sw.active && sw.active.id=='iframe_panel'){
			window_manager_killpane(sw.active);
			window_manager_restore();	
		}
	}else if (type=='blogs'){
#		var extra="vhost=mybox&webmail=true&bgcolor=#FFFFFF&tdcolor=#eeeeff&thcolor=#D6D6CE&border=0&background_image=cust_panel_background&user=marijn@mybox&id=29640"
#		var cmd=backend+"cgi/user.cgi?utoken="+utoken+"&cmd=blogs_list&"+extra;			
		var cmd=cgibase+'cmd=doauto_login&product=usercgi&type=blogs&sid='+sid;
	}else if (type=='photos'){
#		var cmd=backend+'surgeplus/web?utoken='+utoken+'&cmd=sp_file_sharing&hide_menu=true&fname=Pictures/';
		var cmd=cgibase+'cmd=doauto_login&product=surgeplus&type=photos&sid='+sid+'&id='+(new Date()).getTime();
	}else if (type=='calendar'){
#		var cmd=backend+'surgeplus/web?utoken='+utoken+'&cmd=sp_calendar&hide_menu=true';
		var cmd=cgibase+'cmd=doauto_login&product=surgeplus&type=calendar&sid='+sid+'&id='+(new Date()).getTime();
	}else if (type=='contacts'){
		return contacts_mgt_sw();
	}
	if (!cmd) return true;


	sndReq('cmd=show&page=~iframe.htm', function(chan){
		node=actionReqSethtml(chan.responseText,'utility');		
		el=document.getElementById('an_iframe');
		el.src=cmd;		
	});
	return true;
}

function contacts_mgt_sw()
{
	if (!sw.abooks){
		x_alert('Contact information has not yet completed downloading.')
		return false;
	}

	sndReq('cmd=show&page=~contacts.htm', function(chan){
#		// Same in manage_folders
		if (chan.status!=200){
			success_string="Communication error - server not reachable";
			set_status(success_string,'warning');
			return false;
		}
		node=actionReqSethtml(http.responseText,'utility');
		if (global_auth_error){
			global_auth_error=false;
			window_manager_restore();
		}		
	});
	return true;
}	
function contacts_mgt_sp()
{
	var cmd='/surgeplus/web?utoken='+utoken+'&cmd=sp_address_book&hide_menu=true';
	sndReq('cmd=show&page=~iframe.htm', function(chan){
		node=actionReqSethtml(chan.responseText,'utility');		
		el=document.getElementById('an_iframe');
		el.src=cmd;		
	});
}

function allow_images(type,jmsg)
{
	if(!jmsg) jmsg=sw.active.jmsg;
#debugger;
	if(sw.is_popup){
		sw_win.allow_images(type,jmsg);
		show_msg_step2_popup();
		return;	
	}
	var mid,fld;
	if(jmsg){
		fld=jmsg.fld;
		mid=jmsg.cache_mid;
		jmsg_reset(jmsg);
	}else{
		fld=sw.fid;
		mid=cursor_mid;
	}

	var idx=fld+'_'+mid;
	if (sw_cache && sw_cache[idx]) 
		cache_remove(idx,true);

	retrieve_msg(sw.fid,mid,function(){
			if(class_contains(sw.active,'message')&&sw.active.jmsg.cache_mid==mid)
				show_msg_step2_inline(jmsg,sw.active.instance);
			if(preview_mid==mid)
				preview_msg(mid);
		},'&allow_images='+type);
}

# mostly copy of above function see if we can combine
function show_all(type,jmsg)
{
	if(!jmsg) jmsg=sw.active.jmsg;
	if(sw.is_popup){
		sw_win.show_all(type,jmsg);
		show_msg_step2_popup();
		return;	
	}
	var mid,fld;
	if(jmsg){
		fld=jmsg.fld;
		mid=jmsg.cache_mid;
		jmsg_reset(jmsg);
	}else{
		fld=sw.fid;
		mid=cursor_mid;
	}

	var idx=fld+'_'+mid;
	if (sw_cache && sw_cache[idx]) 
		cache_remove(idx,true);

	retrieve_msg(sw.fid,mid,function(){
			if(class_contains(sw.active,'message')&&sw.active.jmsg.cache_mid==mid)
				show_msg_step2_inline(jmsg,sw.active.instance);
			if(preview_mid==mid)
				preview_msg(mid);
		},(type=='attach'?'&all_attach=true':'&all_rcpts=true'));
}

function app_menu(type,o,display_only)
{
	if (!display_only) 
		if(do_old(type)==false)
			return false;
	if(sw.cur_app_menu)
		class_remove(sw.cur_app_menu,"sel");
	var el=document.getElementById("app_"+type);
	if (el){
		class_add(el,"sel");
		sw.cur_app_menu=el;
	}
	if (o) {
		var txt=o.firstChild.innerHTML;
		if (txt=='Contacts') txt='Contact Groups'
		dge('lpanel_hdr_text').innerHTML=txt;
		var q1=dge('lpanel_body');
		if(q1.active_pane) 
			class_add(q1.active_pane,'hidden');
		var q2=dge('lpanel_'+type);
		if (!q2) {
			q2=new_anchor('div','<div style="padding:5px">More "'+txt+'" functionality will be added here as integration is improved. For now, see main panel to the right.</div>',q1);
			q2.id='lpanel_'+type;
		}
		class_remove(q2,'hidden');
		q1.active_pane=q2;
	}
	if (type=='mail'){
		fldmsg_display(enFLD);
	}
}
function app_menu_mail()
{
	if(sw.cur_app_menu  && sw.cur_app_menu.id!='app_mail')	
		app_menu('mail',dge('app_menu_mail'),true);
}


function textMode()
{
	alert("sorry switching to plain text not implemented yet");
}


function do_move(e,id){
	if (!e) e = window.event;
	var t = target(e);
	if (t.tagName.toLowerCase()=='a'){		
		if (class_contains(t,'fake')){
			fld_expand(e);
			stopEvent(e)
			return;
		}		
		do_move_hide(id);
		do_move_actual(t.fname)
	}
#	return stopEvent(e);
}

function do_move_actual(fld)
{
	var sel=find_sel();
	if (!sel) return;
	if (!fld) return;
	set_move_status(sel,fld);
	dbg('do_move - selection ['+sel+']');
	ajax_msg_move(sel,fld);
	do_select('none');
	message_done_action(sel);
}
function do_move_hide(id)
{
	var el=document.getElementById(id);
	class_add(el,'hidden');
}

function do_copy_show(e,input)
{
	do_folder_menu_setup('folder_menu');
	do_menu_show('folder_menu', e, true, function(result,fid){
		var sel=find_sel();
		if (!sel) return;
		if(result!='ok'){
			input.value='';
			return;	
		}
		set_status("Copying...","info");
#		dbg('do_move - selection ['+sel+']');
		ajax_msg_copy(sel,fid);
#		do_select('none');
		input.value='';
	});
}
function do_move_show(e,input)
{
	do_folder_menu_setup('folder_menu');
	do_menu_show('folder_menu',e,true,	function(result,fid){
		var sel=find_sel(true);
		if (!sel) return;

		if(input) input.value='';
		if(result!='ok'){
			return;	
		}
		if(sw.is_popup){
			sw_win.do_move_popup(sw.mid,sw.fid,fid);
			window.close();
			return;
		}
		set_move_status(sel,fid);
		dbg('do_move - selection ['+sel+']');
		ajax_msg_move(sel,fid);
		do_select('none');
		message_done_action(sel);
	});
}

function do_move_popup(mid,src,dst)
{
	var msgs=[mid];
	set_move_status(msgs,dst);
	msgs.fid=src;
	ajax_msg_move(msgs,dst);
}

function refresh(e){
	var t=target(e);
	var el=ancestor_by_class(t,'full_cursor');
	var row=el.parentNode;
	var fld=row.getAttribute('fldid');	

	F(fld,undefined,undefined,true);
	stopEvent(e);
}

# Display folder with particular fid
function F(fid, type, start, refresh, noreset)
{	
	fldmsg_display(enFLD);
	menu_custom_fld(type);
	
	select_mailbox_all('none');
	set_loading("messages_list");
	if(!noreset) search_field_reset();
	var extra=(start==undefined)?"":"&start="+start;
	extra+=(refresh==true)?"&refresh=true":"";
	extra+='&sort='+sw.sort_type+'&rev='+sw.sort_rev;
	o=sw.search_input;
	if(o.valid && sw.search_type=='folder') extra+='&search='+sw.search_input.value;
#	extra+='&keep_selection=true';
	var cmd='cmd=show&page=~msgs.js&fld_id='+fid+extra;
	sndReq(cmd, function(chan){
		doneloading();
		success = actionReqJs(chan);
		if (global_auth_error){
			global_auth_error=false;
			global_request_reissue=cmd;
		}
		if (!success){
			success_string="Communication error - server not reachable";
			set_status('Failed to retrieve message : '+success_string,'warning');
			return;
		}else{
			set_status();
		}
		msgdnd_init();
#		msglist_select(first_message);
	});	
	switch_selfld(fid);
	if(type){
		sw.fld_type=type;
		menu_arrange(type);
	}
	touch(7);
	stop_shift();
}

function msg_previous(msgs,mid)
{
	var last=msgs[0];//-1;//;
	for (var i=0;i<msgs.length; i++) {
	  if (msgs[i]==mid)
	  	break;
	  last=msgs[i];
	}
	if(i==msgs.length && msgs[i]!=mid)
		last=msgs[0];
	return last;
}
function msg_next(msgs,mid)
{
	var last=msgs[msgs.length-1];//-1;//msgs[msgs.length-1];
	for (var i=msgs.length-1;i>=0; i--) {
	  if (msgs[i]==mid)
	  	break;
	  last=msgs[i];
	}
	return last
}
function msg_prev_valid(msgs,mid)
{
	var last=msgs[0];
	for (var i=0;i<msgs.length; i++) {
	  if (class_contains(sel_to_row(dge('sel_'+msgs[i])),'action_pending'))
	  	continue;
	  if (msgs[i]==mid)
	  	break;
	  last=msgs[i];
	}
	return last;
}
function msg_next_valid(msgs,mid)
{
	var last=msgs[msgs.length-1];
	for (var i=msgs.length-1;i; i--) {
	  if (class_contains(sel_to_row(dge('sel_'+msgs[i])),'action_pending'))
	  	continue;
	  if (msgs[i]==mid)
	  	break;
	  last=msgs[i];
	}
	return last
}


function show_prev(mid,nofocus)
{
	var jmsg=sw.active.jmsg;
	if(sw.is_popup){
		if(!compare_folders(jmsg.fld,sw_win.sw.fid)) return;
		sw.active.innerHTML="Loading...";
		sw_win.jmsg_reset(jmsg);
#		Switch to using just find_next + retrieve message??
		jmsg.cache_mid=sw_win.show_prev_preview(mid,true);
		show_msg_step2_popup();
	} else if(class_contains(sw.active,'message')){
		if(!compare_folders(jmsg.fld,sw.fid)) return;
		jmsg_reset(jmsg);
		jmsg.cache_mid=show_prev_preview(mid,true);
		show_msg_step2_inline(jmsg,sw.active.instance);
	}else{
		show_prev_preview(mid,nofocus);
	}
}
function show_prev_preview(mid,nofocus)
{	
	select_none_fast();
	xmid=show_prev_real(mid,true);
	show_soon(xmid,undefined,nofocus);
	return xmid;
}

function show_prev_real(mid,do_end,check_pending)
{
	var msgs=find_msgs();
	var xnew=msg_previous(msgs,mid);
	dbg("show_prev msg="+mid+" prevmsg="+xnew);
	if (xnew==-1){
		mailbox_end=true;
		if (do_end)
			Mx("You have reached the end of the mailbox");
		return mid;
	}
	if(check_pending){
		if(class_contains(sel_to_row(dge('sel_'+xnew)),'action_pending')){
			xnew=msg_next_valid(msgs,mid);
		}
	}
	
	return xnew;
}

function show_next(mid,nofocus)
{
	var jmsg=sw.active.jmsg;
	if(sw.is_popup){
		if(!compare_folders(jmsg.fld,sw_win.sw.fid)) return;
		sw.active.innerHTML="Loading...";
		sw_win.jmsg_reset(jmsg);
#		Switch to using just find_next + retrieve message??
		jmsg.cache_mid=sw_win.show_next_preview(mid,true);
		show_msg_step2_popup();
	} else if(class_contains(sw.active,'message')){
		if(!compare_folders(jmsg.fld,sw.fid)) return;
		jmsg_reset(jmsg);
		jmsg.cache_mid=show_next_preview(mid,true);
		show_msg_step2_inline(jmsg,sw.active.instance);
	}else{
		show_next_preview(mid,nofocus);
	}
}
function show_next_preview(mid,nofocus)
{	
	select_none_fast();
	xmid=show_next_real(mid,true);
	show_soon(xmid,undefined,nofocus);
	return xmid;
}

function show_next_real(mid,do_end,check_pending)
{
#debugger;
	var msgs=find_msgs();
	var xnew=msg_next(msgs,mid);
	dbg("show_next msg="+mid+" nextmsg="+xnew);
	if (xnew==-1){
		mailbox_end=true;
		if (do_end)
			Mx("You have reached the end of the mailbox");
		return mid;
	}
	if(check_pending){
		if(class_contains(sel_to_row(dge('sel_'+xnew)),'action_pending')){
			xnew=msg_prev_valid(msgs,mid);
		}
	}
	return xnew;
}
var showsoon_timer;
# Update message list selection ('cursor') and try download the mesage "soon"
function show_soon(mid,tick,nofocus,nostatus)
{
#	// Can get here from 1) Arrow keys on list page, but may already have opened a message => ignore
#						 2) Prev next arrows in preview pane => show it in preview
#						 4) Prev next arrows in popup/tabbed/inline message => show it in msg display (also in preview)
#						 5) Various message_done_action configurations => action it...
	msglist_select(mid,tick,nofocus);	
	if(showsoon_timer) clearTimeout(showsoon_timer);	
	showsoon_timer=setTimeout(function(){ 
		show_preview(mid,undefined,undefined,nofocus,nostatus);
		showsoon_timer=null; 
	},150);
}


function message_done_action(sel)
{
#	if (sw.util.fldmsg_current==enMSG){
#		or select next message
	var x=pref.message_done_action;
	var x2=pref.message_done_action2;
	var fwd=true;
#	if(!class_contains(sw.active,'fldmsg')){

	if (sw.active!=sw.msgs_pane){
		if(pref.windows=='inline' && x2!='list'){
			x=x2;
		}else{
			if(pref.windows=='tabbed')
				window_manager_killpane(sw.active);
			layout_fldmsg(enFLD);
		}
	}
	if (x=='none') {
		no_msg_sel();
		return;
	}
#	Select next message in list or in message	
	if (x=='prev') fwd=false;
#	if (shiftkey()) fwd=!fwd;
	if (fwd) 
		show_soon(show_next_real(sel[sel.length-1],false),undefined,undefined,true);
	else
		show_soon(show_prev_real(sel[0],false),undefined,undefined,true);
}
function nav(item){
	F(sw.fid,sw.fld_type,item,false,true);	
}


function popout_msg(mid)
{
	show_msg(mid,null,'popup');
	if (sw.active!=sw.msgs_pane){
		if(pref.windows=='inline'){
			layout_fldmsg(enFLD);
		}else{
			window_manager_killpane(sw.active);
			window_manager_restore();
		}
	}	
}

function popin_msg(mid)
{
	sw_win.show_msg(mid,null,'inline');
	window.close();
}

function minimise_edit()
{
	dbg('minimise message clicked');
	
	// if not a message displayed then return for now
	if (pref.windows!='tabbed'){
		if (!confirm("To miminise a message tabbed mode needs to be enabled. Enable tabs mode interface?"))
			return;
			
		pref.windows='tabbed';
		ajax_pref_save('pref_windows='+pref.windows);
		class_remove(document.getElementById('switcher'),'hidden');
	}
	window_manager_minimise(sw.active);	
}

function popout_edit()
{
	var jmsg=jmsg_update(sw.active);
	jmsg.not_new = true;
	show_edit(jmsg,null,'popup');
	if (sw.active!=sw.msgs_pane){
		if(pref.windows=='inline'){
			layout_fldmsg(enFLD);
		}else{
			window_manager_killpane(sw.active);
			window_manager_restore();
		}
	}
}
function popin_edit()
{
	var node=sw.active;
	if(!main_window_check(node)) return;
	var jmsg=jmsg_update(node);
	if (sw_win.pref.windows!='tabbed' && class_contains(sw_win.sw.active,'compose')){
		if (!confirm("You are already editing a message in the main pane. Enable tabs mode interface to continue?"))
			return;
		sw_win.pref.windows='tabbed';
		sw_win.ajax_pref_save('pref_windows='+sw_win.pref.windows);
		sw_win.class_remove(sw_win.document.getElementById('switcher'),'hidden');

	}
	jmsg.from_popout=true;
	jmsg.not_new = true;
	sw_win.show_edit(jmsg,null,'inline');
	sw.closing=true;
	window.close();	
}
function do_reload(interface_ex)
{
	sw.closing=true;
	if (!interface_ex) interface_ex='ajax';
	document.reload.sid.value=sid;
	document.reload.fid.value=sw.fid;
	document.reload.interface_ex.value=interface_ex;
	document.reload.submit()
}
function live_refresh(){
	do_reload();
}

function show_cc(type,node)
{
	var base=node?node:sw.active;

	dbg('show_cc '+type);

	var o=base.field_cc;
	if (type=='bcc')
		o=base.field_bcc;
	
	var po=o;
	while(!class_contains(po,'compose_hdr_row')) po=po.parentNode;
	
	if(class_contains(po,'hidden'))	{
		class_remove(po,'hidden');
	}else{
		class_add(po,'hidden');
		o.value='';
	}

	if(sw.is_popup){
		popup_resize();
	}else{
		do_resize_real();
		stop_shift();
	}
#	FUDGE to make sure buttons are correctly redrawn in IE
	force_redraw(po.parentNode)
}
function check_folder_name(name)
{
	if (name.indexOf('/')==-1 && name.indexOf('\\')==-1) return true;
	x_alert("Invalid folder name - characters used reserved by imap server");
	return false;
}
function do_folder_create()
{
	var new_name;
	var el=dge('folder_new_under');
	var new_name=(el.value.length>0)?el.value+'/':'';
	el=dge('folder_new_name');
	if(!check_folder_name(el.value)) return;
	new_name+=el.value;
	sndReq('cmd=folder_create,show&new_name='+new_name+'&page=~folders.htm', function(chan){
		node=actionReqSethtml(chan.responseText,'utility');
	});
}
function delete_folder(name)
{
	x_confirm('This will permanently delete all mail in the folder "'+name+'". Are you sure?',function(n){
		if (!n)return;
		sndReq('cmd=folder_delete,show&delete_name='+name+'&page=~folders.htm', function(chan){
			node=actionReqSethtml(chan.responseText,'utility');
		});
	});
}


function rename_folder(name,short_name)
{
	x_prompt('Rename the folder "'+short_name+'" to:',short_name,function(val){
		if(!val || !check_folder_name(val)) return;
		var folders='&folder_rename_src='+name+'&folder_rename_dst='+val;
		dbg('renaming '+short_name+' to '+val)
		sndReq('cmd=folder_rename,show&'+folders+'&page=~folders.htm', function(chan){
			node=actionReqSethtml(chan.responseText,'utility');
		});
	});
}

function move_folder(name,short_name)
{		
	x_custom_dlg('Move the folder "'+short_name+'" to:',
				 '<select name="folder_move_dst">'+dge('folder_new_under').innerHTML+'</select>',
				 function(btn){
		val=dge("folder_move_dst").value;
		if(!btn || !val) return;
		var folders='&folder_move_src='+name+'&folder_move_dst='+val;
		dbg('renaming '+name+' to '+val)
		sndReq('cmd=folder_move,show&'+folders+'&page=~folders.htm', function(chan){
			node=actionReqSethtml(chan.responseText,'utility');
		});
	});
}

function do_cache()
{
	var sel=find_sel();
	if (!sel) return;
	if(sel.sel_all) {
		select_mailbox_all('disable');
		alert('Sorry - cannot cache whole mailbox, only caching messages on this page');
	}
	ajax_cache_messages(sel)
}

# IE does not support indexOf on arrays so do it ourselves
function my_indexOf(obj,id){
	if(obj.indexOf) 
		return obj.indexOf(id);

	for(var i=0; i<obj.length; i++){
		if(obj[i]==id){
			return i;
		}
	}
	return -1;
}

function set_seen(sel){
	ajax_set_flags(sel,'set','seen',function(node){class_remove(node,'msg_unread')});
	seen_timer=null;
}

function do_purge(e){
	var t=target(e);
	var el=ancestor_by_class(t,'full_cursor');
	var row=el.parentNode;
	var fld=row.getAttribute('fldid');	
	
	ajax_purge(fld);
	if(sw.fid==fld){
#		F(fld,sw.fld_type,0,true);
		no_msgs_fld();
		no_msg_sel();
		update_unread(fld,"");
		navigator_set(0,0,0,"")
	}
	stop_shift();
	stopEvent(e);
}


function do_print()
{
	var sel=find_sel();
	if (!check_sel(sel,'printed')) return;
	open_popup('cmd=show&page=print.htm&sid='+sid+'&fld_id='+sw.fid+'&msg_id='+sel[0]);
}

function contacts_close()
{
	app_menu('mail',dge('app_menu_mail'));
}

function contacts_new()
{
	cm_contact_edit();
}
function contacts_import()
{
//	x_custom_dlg2('select file to upload in custom dialog with an iframe (including other import flags)',function(){
//		x_alert('importing contacts... with result.');
//		return false;
//	});

	x_custom_dlg2('Select file to upload ',
				 '<iframe id="dlg_iframe" src="" style="width:100%;height:'+px(300)+';background:#ECE9D8;" frameborder="0"></iframe>',
		function(btn){
#			x_custom_dlg2 messes up the standard dialog so much that it is no longer easily reusable so remove completely
			dlg_reset();
#			if(!btn) return;
			cm_contacts_refresh();
		},
		function(){
			var ch=ClientHeight();
			var cw=ClientWidth();
			var o=dge('dlg_win').style;
			o.left=px(0.5*cw-200);
			o.top=px(0.5*ch-200);
			o.width = px(400);	
			
			var xdoc=dge("dlg_iframe").contentWindow.document;

			xdoc.open();
			xdoc.write('<html><head>');
			xdoc.write('<body style="background:#ECE9D8;">'+'Select file to import <br>note: must be outlook csv file, vcf file support will be added soon...<br><form action="||cgi||" method="POST" enctype="multipart/form-data"><input type="file" name="attach"><br><br><input name="add_unrecognised" type="checkbox">Add any unrecognised data as part of the comment<br><input name="cmd_contact_import" type="submit" value="Import"></form>'+'</body></html>')
			xdoc.close();
		});
}

function abks_select()
{	
	var txt;
	var abks=sw.abooks_write;
	for(var i=0;i<abks.length;i++){
		txt+='<option value="'+abks[i]+'">'+abks[i]+'</option>';
	}
	return '<select name="contact_abk_select">'+txt+'</select>';
}
function contacts_new_shared(name,short_name)
{	

	x_custom_dlg('Create new contact in the addressbook:',
				 abks_select(),
				 function(btn){
		var val=dge("contact_abk_select").value;
		if(!btn || !val) return;
		abook_new=val;
		cm_contact_edit();
	});
}
var abook_new="User";


function contacts_copy_shared(name,short_name)
{	
	if(!sw.curr_contact){
		x_alert("Select a contact to copy first.")
		return;
	}
	x_custom_dlg('Copy contact <b><i>'+c_name(sw.curr_contact)+'</i></b> to the addressbook:',
				 abks_select(),
				 function(btn){
		var val=dge("contact_abk_select").value;
		if(!btn || !val) return;
		contact_copy_one(sw.curr_contact,val);
	});
}




function do_contact_email(id)
{
	var e=window.event;
	c=address_book.data[id];
	var rcpt=c_name_co(c)+' <'+c_email(c)+'>';
	var jmsg=compose_jmsg([rcpt]);
	if(pref.windows!='popup' && !e.shiftKey){
		app_menu_mail();
	}
	show_edit(jmsg,e);
}
function do_contact_email2(id,email)
{
	var e=window.event;
	c=address_book.data[id];
	var rcpt=c_name_co(c)+' <'+email+'>'
	var jmsg=compose_jmsg([rcpt]);

	if(pref.windows!='popup'){
		app_menu_mail();
	}
	show_edit(jmsg,e);
}
function do_new_email(name,address)
{
	var e=window.event;
	var rcpt=name+' <'+address+'>';
	var jmsg=compose_jmsg([rcpt]);
	if(pref.windows!='popup' && !(e&&e.shiftKey)){
		app_menu_mail();
	}
	show_edit(jmsg,e);
}


function do_sort(txt)
{
	if (txt!=sw.sort_type){
		sw.sort_rev=(txt=='date'||txt=='size')?true:false;
	} else {
		sw.sort_rev=!sw.sort_rev;
	}
	dge('sort_menu_txt').innerHTML=(sw.sort_rev?'reverse ':'')+txt;
	sw.sort_type=txt;
	F(sw.fid,0,false,false,true);
}

function do_display(txt)
{
	var search;
	dge('display_menu_txt').innerHTML=txt;
	
	if(txt=='day'||txt=='week') search='date:'+txt;
	if(txt=='unread') search='-flags:seen';
	if(txt=='unreplied') search='-flags:replied';
	if(txt=='read') search='flags:seen';
	if(txt=='replied') search='flags:replied';

	do_stype(dge('pg_menu_search').childNodes[1],'folder',search);

	F(sw.fid,0,false,false,true);
}
function do_stype(el,txt,search)
{
	if(!search) do_clear_search();
#	if(sw.search_type==txt) return;
	sw.search_type=txt;
	if(el){
		var o=el.parentNode;
		for (var i=0;i<o.childNodes.length;i++){
			var oo=o.childNodes[i].firstChild;
			if (oo.className) class_remove(oo,'selected');
		}
		class_add(el.firstChild,'selected');
		if(search) {
			search_field_set(search)
		}else{
			search_field_reset();
		}
	}
}	

function search_keyup(e)
{
	if (!e) e = window.event;
#	if (e.keyCode!=13) return;
	dbg("doing search keyup");

	var t = target(e);
	if (e.keyCode==27){
#		apply_quick_search('');
#		search_field_reset();
		do_clear_search();
		dge("mnu_reply").focus();
	}
	if(sw.search_type=='quick'){
		if (e.keyCode!=27){
			apply_quick_search(t.value);
		}	
	}else if(sw.search_type=='folder' || sw.search_type=='all'){

#		Enter
		if (e.keyCode==13){
			dge('display_menu_txt').innerHTML='custom search';
			F(sw.fid,0,false,false,true);
		}	
	}
}
function search_field_reset()
{
	var o=sw.search_input;
	if(sw.search_type=='quick'){
		o.value="Quick search...";
		o.title='Quick search is a browser side search of the messages displayed onthe current page';
	}else if(sw.search_type=='folder'){
		o.value="Server search... (this folder)";
		o.title='This is a serverside search of the header information of all the messages in this folder';
		dge('display_menu_txt').innerHTML='all';
	}else if(sw.search_type=='all'){
		o.value="Server search... (all folders)";
		o.title='This is a serverside search of the header information of all the messages in all folders';
	}
	o.style.color='#777';
	o.valid=false;
	class_add(sw.search_limit,"hidden");	
}
function search_field_set(search)
{
	var o=sw.search_input;
	o.value=(search?search:"");
	o.valid=true;
	o.style.color='black';
	deselect_mailbox_all()
}
function do_clear_search()
{
	sw.search_input.value='';
	if(sw.search_type=='folder'){
		F(sw.fid,0,false,false,true);
	}else{
		apply_quick_search('');
	}
	search_field_reset();
}
function do_search_folder()
{
	class_add(sw.search_limit,"hidden");	
	do_stype(dge('pg_menu_search').childNodes[1],'folder',sw.search_input.value);
	F(sw.fid,0,false,false,true);	
}

function do_move_done()
{
	do_move_actual('Done');
}
function do_download_msg()
{
	var sel=find_sel();
#	if (!check_sel(sel,'printed')) return;
	var xx=cgibase+'cmd=msgpart&sid='+sid+'&fld_id='+sw.fid+'&msg_id='+sel[0]+'&part_id=0&attachment=true';
	window.location.href=xx;
	return;

	setTimeout("window.open(xx,'Download')",5000);
	return;
	var q=dge("qwerty")
	debugger
	q.href=xx;
	dispatch_click(q);
}
